// Project Lab - NHTV IGAD
//////////////////////////////////////////
// Author: Yoshi van Belkom - 130118
//////////////////////////////////////////
// The base Skill Object.
//////////////////////////////////////////

#pragma once

#include "Engine/EngineTypes.h"
#include "DynamicHexMap.h"
#include "SkillObject.generated.h"

class USkillTreeObject;

UCLASS( BlueprintType, meta = (DisplayThumbnail = "true") )
class SKILLTREE_API USkillObject : public UObject
{
	GENERATED_BODY()	
public:
	//A Dynamic Map of Hexagons.
	UPROPERTY( Category = Skill, EditAnywhere )
	FDynamicHexMap hexMap;

	//Pointer to the parent Skill Tree.
	UPROPERTY()
	USkillTreeObject* skillTree;
};
