// Project Lab - NHTV Igad

#pragma once

#include "Components/CapsuleComponent.h"
#include "ConeComponent.generated.h"


UCLASS(ClassGroup = "Collision", editinlinenew, hidecategories = (Object, LOD, Lighting, TextureStreaming), meta = (DisplayName = "Cone Collision", BlueprintSpawnableComponent))
class UNREALPROJECT_API UConeComponent : public UCapsuleComponent
{
	GENERATED_UCLASS_BODY()

public:	
	void BeginPlay() override;

	void UpdateCapsule();

	UPROPERTY(EditAnywhere, export, Category = Shape, meta = (ClampMin = "0", UIMin = "0"))
	float coneRadius = 500.0f;

	UPROPERTY(EditAnywhere, export, Category = Shape, meta = (ClampMin = "0", UIMin = "0"))
	float coneAngle = 50;

	virtual FPrimitiveSceneProxy* CreateSceneProxy() override;
};
