#pragma once
#include "Animation/AnimInstanceProxy.h"
#include "PlayerSetupState.h"

// Animation instance proxy that sets bone scales for character customizations
// This animation proxy just calculates the animation blueprint's pose and then applies bone scaled to them based on character customizations
struct FMainAnimProxy : FAnimInstanceProxy
{
	// The parent animation
	FCharacterCustomization charCustomization;

	// Head
	// Thigh L
	// Thigh R
	// UpperArm L
	// UpperArm R
	// Root
	FName boneNames[7];

	virtual bool Evaluate(FPoseContext& pose) override;
	void SetBoneScale(const FName boneName, const FVector scale, FPoseContext& pose);
};
