// Project Lab - NHTV Igad

#pragma once

#include "Creatures/BossBase.h"
#include "PlayerKeyType.h"
#include "MiniBossCreature.generated.h"

/**
 * 
 */
UCLASS()
class UNREALPROJECT_API AMiniBossCreature : public ABossBase
{
	GENERATED_BODY()
	
public:
	AMiniBossCreature();
	virtual void BeginPlay() override;
	virtual void EndPlay(const EEndPlayReason::Type EndPlayReason) override;
	virtual void Tick(float deltaTime) override; 

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Miniboss")
		TSubclassOf<class ABossBase> inheritAbilities;

	PlayerKeyType keyDropped;

	UPROPERTY(EditAnywhere, BlueprintReadWrite, Category = "Miniboss")
		TSubclassOf<class AEffect> keyEffect;
private:
	TArray<int32> m_bossAbilityPattern;
	float m_castTimer;

};
