// Project Lab - NHTV Igad

#pragma once

#include "GameFramework/SaveGame.h"
#include "Prefs.generated.h"


UCLASS()
class UNREALPROJECT_API UPrefs : public USaveGame
{
	GENERATED_BODY()

public:
	UPrefs(const FObjectInitializer& ObjectInitializer);

	UPROPERTY(BlueprintReadWrite, Category = "Basic")
	FString useControllerName;

	UPROPERTY(BlueprintReadWrite, Category = "Basic")
	float musicVolume;
	UPROPERTY(BlueprintReadWrite, Category = "Basic")
	float sfxVolume;

	UPROPERTY(BlueprintReadWrite, Category = "Graphics")
	bool usingCustomGraphicsSettings;
	UPROPERTY(BlueprintReadWrite, Category = "Graphics")
	TArray<int32> customGraphicsSettings;

public:
	static UPrefs* Load();
	static void Save(UPrefs* settings);
};