// Project Lab - NHTV Igad

#pragma once

#include "Blueprint/UserWidget.h"
#include "ToolTipWidget.generated.h"

/**
 * 
 */

UCLASS()
class UNREALPROJECT_API UToolTipWidget : public UUserWidget
{
	GENERATED_BODY()
	
public:
	virtual void NativeConstruct();
	virtual void NativeDestruct();
	virtual void NativeTick(const FGeometry& geometry, float deltaTime) override;

	UPROPERTY(EditAnywhere, Category = "ToolTip")
	TSubclassOf<class UToolTipText> textWidget;

	UPROPERTY(BlueprintReadWrite, Category = "ToolTip")
	class UCanvasPanel* canvas;

	bool showTooltip;
	FVector2D position;
	FVector2D size;

	void SetTitle(const FString& title);
	void SetText(const FString& text);

private:
	class UToolTipText* m_toolTip;
};
